﻿using OpenSourceCSharpReptile.Properties;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace OpenSourceCSharpReptile
{
    public partial class FrmMain : Form
    {
        public FrmMain()
        {
            InitializeComponent();
            Init();
        }

        void Init()
        {
            this.cbBookWebSite.Items.Add("https://www.biqugeu.net/");
            this.cbBookWebSite.SelectedIndex = 0; 
        }

        private async void btnGetBook_Click(object sender, EventArgs e)
        {
            bool work = false;
            string nextChapter = null;//下一章链接
            string url = null;
            string bookname = null;//章节名
            string bookTitle = null;//书名，用于txt输出命名
            string strHtml = null;

            if (this.btnGetBook.Text == "开始获取")
            {
                this.btnGetBook.Text = "停止获取";
            start:
                try
                {
                    do
                    {
                        if (url == null)
                            url = this.txtBookLink.Text.Trim();
                        HttpItem httpItem = new HttpItem()
                        {
                            URL = url,
                            Method = System.Net.Http.HttpMethod.Get,
                            Allowautoredirect = true,
                            Encoding = Encoding.UTF8
                        };

                        var result = await httpItem.GetHtml();
                        strHtml = result.Html;
                        //获取下一章
                        nextChapter = Regex.Match(strHtml, Resources.biquge_nextChapter).Groups["nextChapter"].ToString();
                        //章节名
                        bookname = Regex.Match(strHtml, Resources.biquge_bookname).Groups["bookname"].ToString();

                        Debug.WriteLine( nextChapter + "\r\n");
                        Debug.WriteLine( bookname+ "\r\n");
                        if (nextChapter.Contains("html"))
                        {
                            url = string.Format(this.cbBookWebSite.Text.ToString() + "{0}", nextChapter);
                            work = true;
                        }
                        else
                            work = false;
                        rtbBook.AppendText("\r\n");
                        rtbBook.AppendText(string.Format("{0}", bookname) + "\r\n");

                        MatchCollection match = Regex.Matches(result.Html
                            , Resources.biquge_data);//获取 匹配文本

                        foreach (Match item in match)
                        {
                            string book = Regex.Match(item.Value, Resources.biquge_data).Groups["data"].ToString().Trim();
                            rtbBook.AppendText(book);                    
                        }
                        Thread.Sleep(500);
                        if (this.btnGetBook.Text == "开始获取")//停止程序
                            break;
                    } while (work);
                    //获取书名
                    bookTitle = Regex.Match(strHtml, Resources.biquge_booktitle).Groups["booktitle"].ToString();
                    //将获取的小说内容写入txt，txt名字就是小说书名
                    AddBookToTXT(this.rtbBook.Text, bookTitle);
                }
                catch (Exception ex)
                {
                    Debug.WriteLine(ex.Message);
                    Debug.WriteLine("goto start");
                    goto start;
                }
            }
            else
            {
                this.btnGetBook.Text = "开始获取";             
            }
        }


        #region 写到txt

        //简洁版
        public static void AddBookToTXT(string logstring, string pathName)
        {
            string path = AppDomain.CurrentDomain.BaseDirectory + pathName + ".txt";
            if (!System.IO.File.Exists(path))
            {
                FileStream stream = System.IO.File.Create(path);
                stream.Close();
                stream.Dispose();
            }
            using (StreamWriter writer = new StreamWriter(path, true))
            {
                writer.WriteLine(logstring);
            }
        }
        #endregion

        private void linkUrl_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            this.linkUrl.Links[0].LinkData = "https://www.biqugeu.net/";
            System.Diagnostics.Process.Start(e.Link.LinkData.ToString());
        }
    }
}
